// $Id: 

Drupal.reference_links = {};
var rl = Drupal.reference_links;
rl.StarWidget = 0;
rl.UpDownWidget = 1;

jQuery(document).ready(function() {
		rl.settings = Drupal.settings.reference_links;
		rl.nid = rl.settings.nid;
		rl.allowRating = rl.settings.allowRating;
		rl.allowDeleting = rl.settings.allowDeleting;
		rl.basePath = Drupal.settings.basePath;

		rl.links = jQuery('#reference_links_container_links');
		
		var add = document.getElementById('reference_links_addnew');
		if (add) {
			var html = '<div id="reference-links-form" style="display: none">';
			html += '<label id="rl-title-label" for="rl-title-text">Title</label>';
			html += '<input id="rl-title-text" type="text" size="40" /><br />';
			html += '<label id="rl-url-label" for="rl-url-text">Url</label>';
			html += '<input id="rl-url-text" type="text" size="40" /><br />';
			html += '</div>';
			
			jQuery('body').append(html);

			rl.addDialog = jQuery('#reference-links-form')
				.dialog({
					width: 325, 
					modal: true,
					resizable: false,
					title: 'Add new link',
					autoOpen: false,
					buttons: [
						{ text: 'Add',
						  click: rl.btnAddClicked
						},
						{ text: 'Cancel',
						  click: function() {
							rl.addDialog.dialog('close');
						  }
						}
					]
				});
		}

		rl.showLinks(rl.settings.data);
	});

rl.decode = function(str) {
	var obj = eval('(' + str + ')');
	return(obj);
}

rl.makeAjaxCall = function(path, params, callback) {
	jQuery.ajax({
		cache: false,
		url: Drupal.settings.basePath + '?q=reference_links/' + path,
		data: params,
		dataType: 'text',
		error: function(request, status, error) {
			alert(status);			
			//$('#container').html(request.responseText);
		},
		success: function(data, status, request) {
			callback(data);
		}
	});
};

rl.addLinkClicked = function() {
	rl.addDialog.dialog('open');
	jQuery('#rl-title-text').val('').focus();
	jQuery('#rl-url-text').val('');
	return (false);
};

rl.btnAddClicked = function() {
	var title = jQuery('#rl-title-text').val();
	var url = jQuery('#rl-url-text').val();
	
	if(title.length == 0 || url.length == 0 || !/(ftp|http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/.test(url)) {
		alert('Please fill all the fields and ensure that you have specified a valid url.');
		return;
	}

	rl.makeAjaxCall('add', {
		nid: rl.nid,
		title: title,
		url: url
	}, function(response) {
		rl.addDialog.dialog('close');

		if (rl.isError(response)) {
			alert(response);
		} else {
			rl.showLinks(rl.decode(response));
		}
	});
};

rl.showLinks = function(links) {
	var nodes = rl.links[0].childNodes;
	for (var i = nodes.length - 1; i >= 0; i--) {
		rl.links[0].removeChild(nodes[i]);
	}

	for (var count=0; count<links.length; count++) {
		var link = links[count];
		var parent = jQuery(document.createElement('div'));

		var div1 = document.createElement('div');
		div1.innerHTML = '<a href="{0}" target="{1}">{2}</a>&nbsp;&nbsp;&nbsp;&nbsp;'.replace("{0}", link.url).replace("{1}", link.target).replace("{2}", link.title);
		var div2 = document.createElement('div');

		parent.append(div1);
		parent.append(div2);

		rl.links.append(parent);
		jQuery(parent).css('clear', 'both');

		div1 = jQuery(div1);
		div1.css('float', 'left');

		if (rl.allowDeleting) {
			var delDiv = jQuery('<div></div>');
			div1.before(delDiv);
			delDiv.css('float', 'left');

			//TODO: Do not assume module path here, but pass it as a setting from the server.
			var delImg = jQuery('<img class="icon-delete" src="{0}" lid="{1}" title="Delete" />'.replace("{0}", rl.basePath + 'sites/all/modules/reference_links/images/s.gif').replace("{1}", link.lid));
			delDiv.append(delImg);
			
			delImg.click(function() {
				var op = confirm('Delete Link: ' + link.title + ' ?');
				if (!op) {
					return;
				}
				rl.makeAjaxCall('delete', {
					nid: rl.nid,
					lid: this.getAttribute('lid')
				}, function(response) {
					if (rl.isError(response)) {
						alert(response);
					} else {
						parent[0].parentNode.removeChild(parent[0]);
					}
				});
			});
		}

		switch (rl.settings.ratingWidget) {
			case rl.StarWidget:
				if (link.rating > rl.settings.numStars) {
					// Number of Stars were decreased after votes were cast. Use
					// the maximum number of stars as per setting.
					link.rating = rl.settings.numStars;
				}
				var select = '<select>';
				var rating = Math.floor(link.rating);
				for(var i=1; i<= rl.settings.numStars; i++) {
					select += '<option';
					if(i==rating) select += ' selected="selected"';
					select += '>' + i + '</option>';
				}
				select += '</select>';
				jQuery(div2).append(select).stars({
					inputType: 'select',
					cancelShow: false,
					disabled: !rl.allowRating,
					callback: function(ui, type, value)
					{
						rl.rateLink(link.lid, value, link.title);
					} 
				});
				break;

			case rl.UpDownWidget:
				jQuery(div2).append('<span class="span-total-rating">(Rating: {0})</span>'.replace("{0}", link.rating));
				var upImg = jQuery('<img class="icon-vote-up" src="{0}" lid="{1}" linkTitle="{2}" title="Vote Up" />'.replace("{0}", rl.basePath + 'sites/all/modules/reference_links/images/s.gif').replace("{1}", link.lid).replace("{2}", link.title));
				jQuery(div2).append(upImg);
				upImg.click(function() {
					rl.rateLink(this.getAttribute('lid'), +1, this.getAttribute('linkTitle'));
				});

				if (rl.settings.allowDown) {
					var downImg = jQuery('<img class="icon-vote-down" src="{0}" lid="{1}" linkTitle="{2}" title="Vote Down" />'.replace("{0}", rl.basePath + 'sites/all/modules/reference_links/images/s.gif').replace("{1}", link.lid).replace("{2}", link.title));
					jQuery(div2).append(downImg);
					downImg.click(function() {
						rl.rateLink(this.getAttribute('lid'), -1, this.getAttribute('linkTitle'));
					});
				}
				break;

			default:
				alert('Invalid Rating Widget. Please contact administrator and report this error.');
		}
	}
};

rl.rateLink = function(lid, rating, title) {
	if (!rl.allowRating) {
		alert('You are not authorized to rate Reference links.');
		return;
	}

	var op = confirm('Update rating ' + rating + ' for the link: ' + title + ' ?');
	if (!op) {
		return;
	}

	rl.makeAjaxCall('rate', {
		nid: rl.nid,
		lid: lid,
		rating: rating
	}, function(response) {
		if (rl.isError(response)) {
			alert(response);
		} else {
			rl.showLinks(rl.decode(response));
		}
	});
}

rl.isError = function(response) {
	if (response.charAt(0) != '[' && response.charAt(0) != '{') {
		return (true);
	} else {
		return (false);
	}
};
